
from grammar.grammar import PATTERN_PARSE

PATTERN_PARSE[:] = [None, None, None]

from grammar.grammar import ANY, TYP, EOF, Ref, NonTerminal
from grammar.ptn_regex import RegexGrammar
from grammar.ptn_ebnf import EBNFLexicalGrammar
from grammar.ptn_ebnf import EBNFGrammar
import grammar

class RegexParser (RegexGrammar, grammar.engine.SourceTrace, grammar.eng_sr.ShiftReduceEngine):
    from grammar.eng_sr import ShiftReduceTable, State, Rule
    regex = RegexGrammar.regex
    _2 = NonTerminal('_2')
    symbol = RegexGrammar.symbol
    srange = RegexGrammar.srange
    production = RegexGrammar.production
    _6 = NonTerminal('_6')
    relem = RegexGrammar.relem
    _5 = NonTerminal('_5')
    _3 = NonTerminal('_3')

    TABLE = ShiftReduceTable('RegexGrammar')
    TABLE.states = [
        #STATE 0
        State([("production -> symbol! ' '* '-' '>' ' '* regex!", 14), ('symbol -> [A-Za-z0-9_]!+!', 10), ('START -> production <EOF>', 9), ('symbol -> [A-Za-z0-9_]!+!', 10), ("production -> symbol! ' '* '-' '>' ' '* regex!", 14), ("production -> symbol! ' '* '-' '>' ' '* regex!", 14), ("production -> symbol! ' '* '-' '>' ' '* regex!", 14), ('symbol -> [A-Za-z0-9_]!+!', 10)], {symbol: ('g', 55), '1': ('s', 12), '0': ('s', 12), '3': ('s', 12), '2': ('s', 12), '5': ('s', 12), '4': ('s', 12), '7': ('s', 12), '6': ('s', 12), '9': ('s', 12), '8': ('s', 12), _6: ('g', 14), 'A': ('s', 12), 'C': ('s', 12), 'B': ('s', 12), 'E': ('s', 12), 'D': ('s', 12), 'G': ('s', 12), 'F': ('s', 12), 'I': ('s', 12), 'H': ('s', 12), 'K': ('s', 12), 'J': ('s', 12), 'M': ('s', 12), 'L': ('s', 12), 'O': ('s', 12), 'N': ('s', 12), 'Q': ('s', 12), 'P': ('s', 12), 'S': ('s', 12), 'R': ('s', 12), 'U': ('s', 12), 'T': ('s', 12), 'W': ('s', 12), 'V': ('s', 12), 'Y': ('s', 12), 'X': ('s', 12), 'Z': ('s', 12), '_': ('s', 12), 'a': ('s', 12), production: ('g', 54), 'c': ('s', 12), 'b': ('s', 12), 'e': ('s', 12), 'd': ('s', 12), 'g': ('s', 12), 'f': ('s', 12), 'i': ('s', 12), 'h': ('s', 12), 'k': ('s', 12), 'j': ('s', 12), 'm': ('s', 12), 'l': ('s', 12), 'o': ('s', 12), 'n': ('s', 12), 'q': ('s', 12), 'p': ('s', 12), 's': ('s', 12), 'r': ('s', 12), 'u': ('s', 12), 't': ('s', 12), 'w': ('s', 12), 'v': ('s', 12), 'y': ('s', 12), 'x': ('s', 12), 'z': ('s', 12)}, 0),
        #STATE 1
        State([("regex -> regex! ':' symbol!", 9), ("regex -> regex! '+'", 9), ("regex -> '.'", 9), ('regex -> \\\\.!', 9), ("regex -> regex! '*'", 9), ("regex -> regex! '?'", 9), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! '|' regex!", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ("regex -> '(' regex! ')'", 9), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ('regex -> [^()*+?!|{:[.\\\\]!', 9), ('regex -> regex! regex!', 9), ('START -> regex <EOF>', 9), ("regex -> regex! '!'", 9)], {regex: ('g', 49), '(': ('s', 4), '.': ('s', 5), ANY(): ('s', 6), '[': ('s', 7), '{': ('s', 8), '\\': ('s', 9)}, 1),
        #STATE 2
        State([("regex -> regex! '+'", 9), ("regex -> '.'", 9), ('regex -> \\\\.!', 9), ("regex -> regex! '*'", 9), ("regex -> regex! '?'", 9), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! '|' regex!", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ("regex -> '(' regex! ')'", 9), ("regex -> regex! '|' regex!", 20), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ('regex -> [^()*+?!|{:[.\\\\]!', 9), ('regex -> regex! regex!', 9), ("regex -> regex! ':' symbol!", 9), ("regex -> regex! '!'", 9)], {regex: ('g', 3), '(': ('s', 4), '.': ('s', 5), ANY(): ('s', 6), '[': ('s', 7), '{': ('s', 8), '\\': ('s', 9)}, 2),
        #STATE 3
        State([("regex -> regex! '!'", 16), ('regex -> \\\\.!', 9), ("regex -> regex! '|' regex!", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ('regex -> regex! regex!', 9), ("regex -> regex! '!'", 9), ("regex -> regex! '+'", 16), ("regex -> regex! '*'", 16), ("regex -> '(' regex! ')'", 9), ("regex -> regex! '|' regex!", 25), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ("regex -> regex! '+'", 9), ("regex -> regex! '*'", 9), ('regex -> [^()*+?!|{:[.\\\\]!', 9), ("regex -> regex! '?'", 16), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! ':' symbol!", 16), ("regex -> '.'", 9), ("regex -> regex! '?'", 9), ("regex -> regex! '|' regex!", 16), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! ':' symbol!", 9), ('regex -> regex! regex!', 16)], {'!': ('s', 29), regex: ('g', 28), ')': ('r', 25), '(': ('s', 4), '+': ('s', 30), '*': ('s', 31), '.': ('s', 5), ANY(): ('s', 6), EOF: ('r', 25), '\\': ('s', 9), '[': ('s', 7), ':': ('s', 33), '{': ('s', 8), '?': ('s', 32), '|': ('r', 25)}, 3),
        #STATE 4
        State([("regex -> regex! '+'", 9), ("regex -> '.'", 9), ('regex -> \\\\.!', 9), ("regex -> regex! '*'", 9), ("regex -> regex! '?'", 9), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! '|' regex!", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> '(' regex! ')'", 9), ("regex -> '(' regex! ')'", 13), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ('regex -> [^()*+?!|{:[.\\\\]!', 9), ('regex -> regex! regex!', 9), ("regex -> regex! ':' symbol!", 9), ("regex -> regex! '!'", 9)], {regex: ('g', 26), '(': ('s', 4), '.': ('s', 5), ANY(): ('s', 6), '[': ('s', 7), '{': ('s', 8), '\\': ('s', 9)}, 4),
        #STATE 5
        State([("regex -> '.'", 12)], {'!': ('r', 14), ')': ('r', 14), EOF: ('r', 14), '+': ('r', 14), '*': ('r', 14), '.': ('r', 14), ANY(): ('r', 14), '(': ('r', 14), '{': ('r', 14), '[': ('r', 14), ':': ('r', 14), '\\': ('r', 14), '?': ('r', 14), '|': ('r', 14)}, 5),
        #STATE 6
        State([('regex -> [^()*+?!|{:[.\\\\]!', 25)], {'!': ('r', 28), ')': ('r', 28), EOF: ('r', 28), '+': ('r', 28), '*': ('r', 28), '.': ('r', 28), ANY(): ('r', 28), '(': ('r', 28), '{': ('r', 28), '[': ('r', 28), ':': ('r', 28), '\\': ('r', 28), '?': ('r', 28), '|': ('r', 28)}, 6),
        #STATE 7
        State([("regex -> '[' '^'?:inv srange!+! ']'", 22), ("srange -> relem:a ('-' relem:b)?", 10), ("regex -> '[' '^'?:inv srange!+! ']'", 22), ('relem -> [^\\\\\\]]!', 9), ("regex -> '[' '^'?:inv srange!+! ']'", 22), ('relem -> \\\\.!', 9), ("regex -> '[' '^'?:inv srange!+! ']'", 13), ("srange -> relem:a ('-' relem:b)?", 10)], {relem: ('g', 18), _5: ('g', 15), '\\': ('s', 19), ANY(): ('s', 16), srange: ('g', 37), '^': ('s', 35)}, 7),
        #STATE 8
        State([("regex -> '{' symbol! (':' symbol!)? '}'", 13), ('symbol -> [A-Za-z0-9_]!+!', 10), ('symbol -> [A-Za-z0-9_]!+!', 10), ("regex -> '{' symbol! (':' symbol!)? '}'", 13), ('symbol -> [A-Za-z0-9_]!+!', 10)], {symbol: ('g', 46), '1': ('s', 12), '0': ('s', 12), '3': ('s', 12), '2': ('s', 12), '5': ('s', 12), '4': ('s', 12), '7': ('s', 12), '6': ('s', 12), '9': ('s', 12), '8': ('s', 12), _6: ('g', 14), 'A': ('s', 12), 'C': ('s', 12), 'B': ('s', 12), 'E': ('s', 12), 'D': ('s', 12), 'G': ('s', 12), 'F': ('s', 12), 'I': ('s', 12), 'H': ('s', 12), 'K': ('s', 12), 'J': ('s', 12), 'M': ('s', 12), 'L': ('s', 12), 'O': ('s', 12), 'N': ('s', 12), 'Q': ('s', 12), 'P': ('s', 12), 'S': ('s', 12), 'R': ('s', 12), 'U': ('s', 12), 'T': ('s', 12), 'W': ('s', 12), 'V': ('s', 12), 'Y': ('s', 12), 'X': ('s', 12), 'Z': ('s', 12), '_': ('s', 12), 'a': ('s', 12), 'c': ('s', 12), 'b': ('s', 12), 'e': ('s', 12), 'd': ('s', 12), 'g': ('s', 12), 'f': ('s', 12), 'i': ('s', 12), 'h': ('s', 12), 'k': ('s', 12), 'j': ('s', 12), 'm': ('s', 12), 'l': ('s', 12), 'o': ('s', 12), 'n': ('s', 12), 'q': ('s', 12), 'p': ('s', 12), 's': ('s', 12), 'r': ('s', 12), 'u': ('s', 12), 't': ('s', 12), 'w': ('s', 12), 'v': ('s', 12), 'y': ('s', 12), 'x': ('s', 12), 'z': ('s', 12)}, 8),
        #STATE 9
        State([('regex -> \\\\.!', 11)], {ANY(): ('s', 10)}, 9),
        #STATE 10
        State([('regex -> \\\\.!', 12)], {'!': ('r', 1), ')': ('r', 1), EOF: ('r', 1), '+': ('r', 1), '*': ('r', 1), '.': ('r', 1), ANY(): ('r', 1), '?': ('r', 1), '(': ('r', 1), '{': ('r', 1), ':': ('r', 1), '[': ('r', 1), '\\': ('r', 1), '|': ('r', 1)}, 10),
        #STATE 11
        State([('symbol -> [A-Za-z0-9_]!+!', 10), ("regex -> '{' symbol! (':' symbol!)? '}'", 26), ('symbol -> [A-Za-z0-9_]!+!', 10), ('symbol -> [A-Za-z0-9_]!+!', 10)], {symbol: ('g', 13), '1': ('s', 12), '0': ('s', 12), '3': ('s', 12), '2': ('s', 12), '5': ('s', 12), '4': ('s', 12), '7': ('s', 12), '6': ('s', 12), '9': ('s', 12), '8': ('s', 12), _6: ('g', 14), 'A': ('s', 12), 'C': ('s', 12), 'B': ('s', 12), 'E': ('s', 12), 'D': ('s', 12), 'G': ('s', 12), 'F': ('s', 12), 'I': ('s', 12), 'H': ('s', 12), 'K': ('s', 12), 'J': ('s', 12), 'M': ('s', 12), 'L': ('s', 12), 'O': ('s', 12), 'N': ('s', 12), 'Q': ('s', 12), 'P': ('s', 12), 'S': ('s', 12), 'R': ('s', 12), 'U': ('s', 12), 'T': ('s', 12), 'W': ('s', 12), 'V': ('s', 12), 'Y': ('s', 12), 'X': ('s', 12), 'Z': ('s', 12), '_': ('s', 12), 'a': ('s', 12), 'c': ('s', 12), 'b': ('s', 12), 'e': ('s', 12), 'd': ('s', 12), 'g': ('s', 12), 'f': ('s', 12), 'i': ('s', 12), 'h': ('s', 12), 'k': ('s', 12), 'j': ('s', 12), 'm': ('s', 12), 'l': ('s', 12), 'o': ('s', 12), 'n': ('s', 12), 'q': ('s', 12), 'p': ('s', 12), 's': ('s', 12), 'r': ('s', 12), 'u': ('s', 12), 't': ('s', 12), 'w': ('s', 12), 'v': ('s', 12), 'y': ('s', 12), 'x': ('s', 12), 'z': ('s', 12)}, 11),
        #STATE 12
        State([('symbol -> [A-Za-z0-9_]!+!', 22)], {EOF: ('r', 29), '!': ('r', 29), ' ': ('r', 29), ')': ('r', 29), '(': ('r', 29), '+': ('r', 29), '*': ('r', 29), '-': ('r', 29), '.': ('r', 29), '1': ('r', 29), '0': ('r', 29), '3': ('r', 29), '2': ('r', 29), '5': ('r', 29), '4': ('r', 29), '7': ('r', 29), '6': ('r', 29), '9': ('r', 29), '8': ('r', 29), ':': ('r', 29), '?': ('r', 29), 'A': ('r', 29), 'C': ('r', 29), 'B': ('r', 29), 'E': ('r', 29), 'D': ('r', 29), 'G': ('r', 29), 'F': ('r', 29), 'I': ('r', 29), 'H': ('r', 29), 'K': ('r', 29), 'J': ('r', 29), 'M': ('r', 29), 'L': ('r', 29), 'O': ('r', 29), 'N': ('r', 29), ANY(): ('r', 29), 'P': ('r', 29), 'S': ('r', 29), 'R': ('r', 29), 'U': ('r', 29), 'T': ('r', 29), 'W': ('r', 29), 'V': ('r', 29), 'Y': ('r', 29), 'X': ('r', 29), '[': ('r', 29), 'Z': ('r', 29), '\\': ('r', 29), '_': ('r', 29), 'a': ('r', 29), 'Q': ('r', 29), 'c': ('r', 29), 'b': ('r', 29), 'e': ('r', 29), 'd': ('r', 29), 'g': ('r', 29), 'f': ('r', 29), 'i': ('r', 29), 'h': ('r', 29), 'k': ('r', 29), 'j': ('r', 29), 'm': ('r', 29), 'l': ('r', 29), 'o': ('r', 29), 'n': ('r', 29), 'q': ('r', 29), 'p': ('r', 29), 's': ('r', 29), 'r': ('r', 29), 'u': ('r', 29), 't': ('r', 29), 'w': ('r', 29), 'v': ('r', 29), 'y': ('r', 29), 'x': ('r', 29), '{': ('r', 29), 'z': ('r', 29), '}': ('r', 29), '|': ('r', 29)}, 12),
        #STATE 13
        State([("regex -> '{' symbol! (':' symbol!)? '}'", 36)], {'}': ('s', 59)}, 13),
        #STATE 14
        State([('symbol -> [A-Za-z0-9_]!+!', 10), ('symbol -> [A-Za-z0-9_]!+!', 24)], {EOF: ('r', 3), '!': ('r', 3), ' ': ('r', 3), ')': ('r', 3), '(': ('r', 3), '+': ('r', 3), '*': ('r', 3), '-': ('r', 3), '.': ('r', 3), '1': ('s', 21), '0': ('s', 21), '3': ('s', 21), '2': ('s', 21), '5': ('s', 21), '4': ('s', 21), '7': ('s', 21), '6': ('s', 21), '9': ('s', 21), '8': ('s', 21), ':': ('r', 3), '?': ('r', 3), 'A': ('s', 21), 'C': ('s', 21), 'B': ('s', 21), 'E': ('s', 21), 'D': ('s', 21), 'G': ('s', 21), 'F': ('s', 21), 'I': ('s', 21), 'H': ('s', 21), 'K': ('s', 21), 'J': ('s', 21), 'M': ('s', 21), 'L': ('s', 21), 'O': ('s', 21), 'N': ('s', 21), 'Q': ('s', 21), 'P': ('s', 21), 'S': ('s', 21), 'R': ('s', 21), 'U': ('s', 21), 'T': ('s', 21), 'W': ('s', 21), 'V': ('s', 21), 'Y': ('s', 21), 'X': ('s', 21), '[': ('r', 3), 'Z': ('s', 21), '\\': ('r', 3), '_': ('s', 21), 'a': ('s', 21), ANY(): ('r', 3), 'c': ('s', 21), 'b': ('s', 21), 'e': ('s', 21), 'd': ('s', 21), 'g': ('s', 21), 'f': ('s', 21), 'i': ('s', 21), 'h': ('s', 21), 'k': ('s', 21), 'j': ('s', 21), 'm': ('s', 21), 'l': ('s', 21), 'o': ('s', 21), 'n': ('s', 21), 'q': ('s', 21), 'p': ('s', 21), 's': ('s', 21), 'r': ('s', 21), 'u': ('s', 21), 't': ('s', 21), 'w': ('s', 21), 'v': ('s', 21), 'y': ('s', 21), 'x': ('s', 21), '{': ('r', 3), 'z': ('s', 21), '}': ('r', 3), '|': ('r', 3)}, 14),
        #STATE 15
        State([("srange -> relem:a ('-' relem:b)?", 10), ("srange -> relem:a ('-' relem:b)?", 10), ("regex -> '[' '^'?:inv srange!+! ']'", 22), ('relem -> [^\\\\\\]]!', 9), ('relem -> \\\\.!', 9), ("regex -> '[' '^'?:inv srange!+! ']'", 32)], {ANY(): ('s', 16), srange: ('g', 20), ']': ('s', 17), relem: ('g', 18), '\\': ('s', 19)}, 15),
        #STATE 16
        State([('relem -> [^\\\\\\]]!', 16)], {ANY(): ('r', 18), '-': ('r', 18), ']': ('r', 18), '\\': ('r', 18)}, 16),
        #STATE 17
        State([("regex -> '[' '^'?:inv srange!+! ']'", 35)], {'!': ('r', 9), ')': ('r', 9), EOF: ('r', 9), '+': ('r', 9), '*': ('r', 9), '.': ('r', 9), ANY(): ('r', 9), '(': ('r', 9), '\\': ('r', 9), '{': ('r', 9), ':': ('r', 9), '[': ('r', 9), '?': ('r', 9), '|': ('r', 9)}, 17),
        #STATE 18
        State([("srange -> relem:a ('-' relem:b)?", 15), ("srange -> relem:a ('-' relem:b)?", 19)], {ANY(): ('r', 17), ']': ('r', 17), '-': ('s', 22), '\\': ('r', 17)}, 18),
        #STATE 19
        State([('relem -> \\\\.!', 11)], {ANY(): ('s', 48)}, 19),
        #STATE 20
        State([("regex -> '[' '^'?:inv srange!+! ']'", 28)], {ANY(): ('r', 7), ']': ('r', 7), '\\': ('r', 7)}, 20),
        #STATE 21
        State([('symbol -> [A-Za-z0-9_]!+!', 22)], {EOF: ('r', 0), '!': ('r', 0), ' ': ('r', 0), ')': ('r', 0), '(': ('r', 0), '+': ('r', 0), '*': ('r', 0), '-': ('r', 0), '.': ('r', 0), '1': ('r', 0), '0': ('r', 0), '3': ('r', 0), '2': ('r', 0), '5': ('r', 0), '4': ('r', 0), '7': ('r', 0), '6': ('r', 0), '9': ('r', 0), '8': ('r', 0), ':': ('r', 0), '?': ('r', 0), 'A': ('r', 0), 'C': ('r', 0), 'B': ('r', 0), 'E': ('r', 0), 'D': ('r', 0), 'G': ('r', 0), 'F': ('r', 0), 'I': ('r', 0), 'H': ('r', 0), 'K': ('r', 0), 'J': ('r', 0), 'M': ('r', 0), 'L': ('r', 0), 'O': ('r', 0), 'N': ('r', 0), ANY(): ('r', 0), 'P': ('r', 0), 'S': ('r', 0), 'R': ('r', 0), 'U': ('r', 0), 'T': ('r', 0), 'W': ('r', 0), 'V': ('r', 0), 'Y': ('r', 0), 'X': ('r', 0), '[': ('r', 0), 'Z': ('r', 0), '\\': ('r', 0), '_': ('r', 0), 'a': ('r', 0), 'Q': ('r', 0), 'c': ('r', 0), 'b': ('r', 0), 'e': ('r', 0), 'd': ('r', 0), 'g': ('r', 0), 'f': ('r', 0), 'i': ('r', 0), 'h': ('r', 0), 'k': ('r', 0), 'j': ('r', 0), 'm': ('r', 0), 'l': ('r', 0), 'o': ('r', 0), 'n': ('r', 0), 'q': ('r', 0), 'p': ('r', 0), 's': ('r', 0), 'r': ('r', 0), 'u': ('r', 0), 't': ('r', 0), 'w': ('r', 0), 'v': ('r', 0), 'y': ('r', 0), 'x': ('r', 0), '{': ('r', 0), 'z': ('r', 0), '}': ('r', 0), '|': ('r', 0)}, 21),
        #STATE 22
        State([("srange -> relem:a ('-' relem:b)?", 23), ('relem -> \\\\.!', 9), ('relem -> [^\\\\\\]]!', 9)], {ANY(): ('s', 16), relem: ('g', 23), '\\': ('s', 19)}, 22),
        #STATE 23
        State([("srange -> relem:a ('-' relem:b)?", 28)], {ANY(): ('r', 2), ']': ('r', 2), '\\': ('r', 2)}, 23),
        #STATE 24
        State([("production -> symbol! ' '* '-' '>' ' '* regex!", 31), ("production -> symbol! ' '* '-' '>' ' '* regex!", 31)], {'>': ('s', 25)}, 24),
        #STATE 25
        State([("production -> symbol! ' '* '-' '>' ' '* regex!", 22), ("production -> symbol! ' '* '-' '>' ' '* regex!", 22), ("regex -> '.'", 9), ("production -> symbol! ' '* '-' '>' ' '* regex!", 40), ("regex -> regex! '*'", 9), ("regex -> regex! '?'", 9), ("production -> symbol! ' '* '-' '>' ' '* regex!", 22), ("regex -> regex! '+'", 9), ("regex -> regex! '|' regex!", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ("regex -> '(' regex! ')'", 9), ("production -> symbol! ' '* '-' '>' ' '* regex!", 22), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ('regex -> \\\\.!', 9), ('regex -> [^()*+?!|{:[.\\\\]!', 9), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ('regex -> regex! regex!', 9), ("regex -> regex! ':' symbol!", 9), ("regex -> regex! '!'", 9)], {_2: ('g', 39), ' ': ('s', 40), regex: ('g', 41), '(': ('s', 4), '.': ('s', 5), ANY(): ('s', 6), _3: ('g', 42), '{': ('s', 8), '[': ('s', 7), '\\': ('s', 9)}, 25),
        #STATE 26
        State([("regex -> regex! '!'", 16), ('regex -> \\\\.!', 9), ("regex -> regex! '|' regex!", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ('regex -> regex! regex!', 9), ("regex -> regex! '!'", 9), ("regex -> regex! '+'", 16), ("regex -> regex! '*'", 16), ("regex -> '(' regex! ')'", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ("regex -> regex! '+'", 9), ("regex -> regex! '*'", 9), ('regex -> [^()*+?!|{:[.\\\\]!', 9), ("regex -> regex! '?'", 16), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! ':' symbol!", 16), ("regex -> '.'", 9), ("regex -> regex! '?'", 9), ("regex -> regex! '|' regex!", 16), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> '(' regex! ')'", 20), ("regex -> regex! ':' symbol!", 9), ('regex -> regex! regex!', 16)], {'!': ('s', 29), regex: ('g', 28), ')': ('s', 51), '(': ('s', 4), '+': ('s', 30), '*': ('s', 31), '.': ('s', 5), ANY(): ('s', 6), '\\': ('s', 9), '[': ('s', 7), ':': ('s', 33), '{': ('s', 8), '?': ('s', 32), '|': ('s', 2)}, 26),
        #STATE 27
        State([("regex -> '{' symbol! (':' symbol!)? '}'", 39)], {'!': ('r', 4), ')': ('r', 4), EOF: ('r', 4), '+': ('r', 4), '*': ('r', 4), '.': ('r', 4), ANY(): ('r', 4), '(': ('r', 4), '\\': ('r', 4), '{': ('r', 4), ':': ('r', 4), '[': ('r', 4), '?': ('r', 4), '|': ('r', 4)}, 27),
        #STATE 28
        State([("regex -> regex! '!'", 16), ('regex -> \\\\.!', 9), ("regex -> regex! '|' regex!", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ('regex -> regex! regex!', 9), ("regex -> regex! '!'", 9), ("regex -> regex! '+'", 16), ("regex -> regex! '*'", 16), ("regex -> '(' regex! ')'", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ("regex -> regex! '+'", 9), ("regex -> regex! '*'", 9), ('regex -> [^()*+?!|{:[.\\\\]!', 9), ("regex -> regex! '?'", 16), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! ':' symbol!", 16), ("regex -> '.'", 9), ('regex -> regex! regex!', 21), ("regex -> regex! '?'", 9), ("regex -> regex! '|' regex!", 16), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! ':' symbol!", 9), ('regex -> regex! regex!', 16)], {'!': ('s', 29), regex: ('g', 28), ')': ('r', 5), '(': ('s', 4), '+': ('s', 30), '*': ('s', 31), '.': ('s', 5), ANY(): ('s', 6), EOF: ('r', 5), '\\': ('s', 9), '[': ('s', 7), ':': ('s', 33), '{': ('s', 8), '?': ('s', 32), '|': ('r', 5)}, 28),
        #STATE 29
        State([("regex -> regex! '!'", 19)], {'!': ('r', 10), ')': ('r', 10), EOF: ('r', 10), '+': ('r', 10), '*': ('r', 10), '.': ('r', 10), ANY(): ('r', 10), '(': ('r', 10), '{': ('r', 10), '[': ('r', 10), ':': ('r', 10), '\\': ('r', 10), '?': ('r', 10), '|': ('r', 10)}, 29),
        #STATE 30
        State([("regex -> regex! '+'", 19)], {'!': ('r', 20), ')': ('r', 20), EOF: ('r', 20), '+': ('r', 20), '*': ('r', 20), '.': ('r', 20), ANY(): ('r', 20), '(': ('r', 20), '{': ('r', 20), '[': ('r', 20), ':': ('r', 20), '\\': ('r', 20), '?': ('r', 20), '|': ('r', 20)}, 30),
        #STATE 31
        State([("regex -> regex! '*'", 19)], {'!': ('r', 30), ')': ('r', 30), EOF: ('r', 30), '+': ('r', 30), '*': ('r', 30), '.': ('r', 30), ANY(): ('r', 30), '(': ('r', 30), '{': ('r', 30), '[': ('r', 30), ':': ('r', 30), '\\': ('r', 30), '?': ('r', 30), '|': ('r', 30)}, 31),
        #STATE 32
        State([("regex -> regex! '?'", 19)], {'!': ('r', 13), ')': ('r', 13), EOF: ('r', 13), '+': ('r', 13), '*': ('r', 13), '.': ('r', 13), ANY(): ('r', 13), '(': ('r', 13), '{': ('r', 13), '[': ('r', 13), ':': ('r', 13), '\\': ('r', 13), '?': ('r', 13), '|': ('r', 13)}, 32),
        #STATE 33
        State([("regex -> regex! ':' symbol!", 20), ('symbol -> [A-Za-z0-9_]!+!', 10), ('symbol -> [A-Za-z0-9_]!+!', 10), ('symbol -> [A-Za-z0-9_]!+!', 10)], {symbol: ('g', 38), '1': ('s', 12), '0': ('s', 12), '3': ('s', 12), '2': ('s', 12), '5': ('s', 12), '4': ('s', 12), '7': ('s', 12), '6': ('s', 12), '9': ('s', 12), '8': ('s', 12), _6: ('g', 14), 'A': ('s', 12), 'C': ('s', 12), 'B': ('s', 12), 'E': ('s', 12), 'D': ('s', 12), 'G': ('s', 12), 'F': ('s', 12), 'I': ('s', 12), 'H': ('s', 12), 'K': ('s', 12), 'J': ('s', 12), 'M': ('s', 12), 'L': ('s', 12), 'O': ('s', 12), 'N': ('s', 12), 'Q': ('s', 12), 'P': ('s', 12), 'S': ('s', 12), 'R': ('s', 12), 'U': ('s', 12), 'T': ('s', 12), 'W': ('s', 12), 'V': ('s', 12), 'Y': ('s', 12), 'X': ('s', 12), 'Z': ('s', 12), '_': ('s', 12), 'a': ('s', 12), 'c': ('s', 12), 'b': ('s', 12), 'e': ('s', 12), 'd': ('s', 12), 'g': ('s', 12), 'f': ('s', 12), 'i': ('s', 12), 'h': ('s', 12), 'k': ('s', 12), 'j': ('s', 12), 'm': ('s', 12), 'l': ('s', 12), 'o': ('s', 12), 'n': ('s', 12), 'q': ('s', 12), 'p': ('s', 12), 's': ('s', 12), 'r': ('s', 12), 'u': ('s', 12), 't': ('s', 12), 'w': ('s', 12), 'v': ('s', 12), 'y': ('s', 12), 'x': ('s', 12), 'z': ('s', 12)}, 33),
        #STATE 34
        State([('START -> production <EOF>', 25)], {}, 34),
        #STATE 35
        State([("regex -> '[' '^'?:inv srange!+! ']'", 22), ("srange -> relem:a ('-' relem:b)?", 10), ("srange -> relem:a ('-' relem:b)?", 10), ('relem -> [^\\\\\\]]!', 9), ('relem -> \\\\.!', 9), ("regex -> '[' '^'?:inv srange!+! ']'", 22), ("regex -> '[' '^'?:inv srange!+! ']'", 22)], {ANY(): ('s', 16), srange: ('g', 37), relem: ('g', 18), '\\': ('s', 19), _5: ('g', 36)}, 35),
        #STATE 36
        State([("srange -> relem:a ('-' relem:b)?", 10), ("srange -> relem:a ('-' relem:b)?", 10), ("regex -> '[' '^'?:inv srange!+! ']'", 22), ('relem -> [^\\\\\\]]!', 9), ('relem -> \\\\.!', 9), ("regex -> '[' '^'?:inv srange!+! ']'", 32)], {ANY(): ('s', 16), srange: ('g', 20), ']': ('s', 45), relem: ('g', 18), '\\': ('s', 19)}, 36),
        #STATE 37
        State([("regex -> '[' '^'?:inv srange!+! ']'", 28)], {ANY(): ('r', 26), ']': ('r', 26), '\\': ('r', 26)}, 37),
        #STATE 38
        State([("regex -> regex! ':' symbol!", 26)], {'!': ('r', 6), ')': ('r', 6), EOF: ('r', 6), '+': ('r', 6), '*': ('r', 6), '.': ('r', 6), ANY(): ('r', 6), '?': ('r', 6), '(': ('r', 6), '{': ('r', 6), ':': ('r', 6), '[': ('r', 6), '\\': ('r', 6), '|': ('r', 6)}, 38),
        #STATE 39
        State([("regex -> regex! '+'", 9), ("regex -> '.'", 9), ("production -> symbol! ' '* '-' '>' ' '* regex!", 40), ("regex -> regex! '*'", 9), ("production -> symbol! ' '* '-' '>' ' '* regex!", 22), ("regex -> regex! '?'", 9), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! '|' regex!", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ("regex -> '(' regex! ')'", 9), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ('regex -> \\\\.!', 9), ("production -> symbol! ' '* '-' '>' ' '* regex!", 22), ('regex -> [^()*+?!|{:[.\\\\]!', 9), ('regex -> regex! regex!', 9), ("regex -> regex! ':' symbol!", 9), ("regex -> regex! '!'", 9)], {regex: ('g', 47), ' ': ('s', 40), '(': ('s', 4), '.': ('s', 5), ANY(): ('s', 6), _3: ('g', 44), '{': ('s', 8), '[': ('s', 7), '\\': ('s', 9)}, 39),
        #STATE 40
        State([("production -> symbol! ' '* '-' '>' ' '* regex!", 25)], {' ': ('r', 21), '(': ('r', 21), '-': ('r', 21), '.': ('r', 21), ANY(): ('r', 21), '[': ('r', 21), '{': ('r', 21), '\\': ('r', 21)}, 40),
        #STATE 41
        State([("regex -> regex! '!'", 16), ('regex -> \\\\.!', 9), ("regex -> regex! '|' regex!", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ('regex -> regex! regex!', 9), ("regex -> regex! '!'", 9), ("regex -> regex! '+'", 16), ("regex -> regex! '*'", 16), ("regex -> '(' regex! ')'", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ("regex -> regex! '+'", 9), ("regex -> regex! '*'", 9), ("production -> symbol! ' '* '-' '>' ' '* regex!", 45), ('regex -> [^()*+?!|{:[.\\\\]!', 9), ("regex -> regex! '?'", 16), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! ':' symbol!", 16), ("regex -> '.'", 9), ("regex -> regex! '?'", 9), ("regex -> regex! '|' regex!", 16), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! ':' symbol!", 9), ('regex -> regex! regex!', 16)], {'!': ('s', 29), regex: ('g', 28), '(': ('s', 4), '+': ('s', 30), '*': ('s', 31), '.': ('s', 5), ANY(): ('s', 6), EOF: ('r', 19), '\\': ('s', 9), '[': ('s', 7), ':': ('s', 33), '{': ('s', 8), '?': ('s', 32), '|': ('s', 2)}, 41),
        #STATE 42
        State([("production -> symbol! ' '* '-' '>' ' '* regex!", 25)], {' ': ('r', 11), '(': ('r', 11), '-': ('r', 11), '.': ('r', 11), ANY(): ('r', 11), '[': ('r', 11), '{': ('r', 11), '\\': ('r', 11)}, 42),
        #STATE 43
        State([("production -> symbol! ' '* '-' '>' ' '* regex!", 27), ("production -> symbol! ' '* '-' '>' ' '* regex!", 22), ("production -> symbol! ' '* '-' '>' ' '* regex!", 22), ("production -> symbol! ' '* '-' '>' ' '* regex!", 27)], {' ': ('s', 40), '-': ('s', 24), _3: ('g', 44)}, 43),
        #STATE 44
        State([("production -> symbol! ' '* '-' '>' ' '* regex!", 25)], {' ': ('r', 22), '(': ('r', 22), '-': ('r', 22), '.': ('r', 22), ANY(): ('r', 22), '[': ('r', 22), '{': ('r', 22), '\\': ('r', 22)}, 44),
        #STATE 45
        State([("regex -> '[' '^'?:inv srange!+! ']'", 35)], {'!': ('r', 8), ')': ('r', 8), EOF: ('r', 8), '+': ('r', 8), '*': ('r', 8), '.': ('r', 8), ANY(): ('r', 8), '(': ('r', 8), '[': ('r', 8), '{': ('r', 8), ':': ('r', 8), '\\': ('r', 8), '?': ('r', 8), '|': ('r', 8)}, 45),
        #STATE 46
        State([("regex -> '{' symbol! (':' symbol!)? '}'", 22), ("regex -> '{' symbol! (':' symbol!)? '}'", 36)], {':': ('s', 11), '}': ('s', 27)}, 46),
        #STATE 47
        State([("regex -> regex! '!'", 16), ('regex -> \\\\.!', 9), ("regex -> regex! '|' regex!", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ('regex -> regex! regex!', 9), ("regex -> regex! '!'", 9), ("regex -> regex! '+'", 16), ("regex -> regex! '*'", 16), ("regex -> '(' regex! ')'", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ("regex -> regex! '+'", 9), ("regex -> regex! '*'", 9), ('regex -> [^()*+?!|{:[.\\\\]!', 9), ("regex -> regex! '?'", 16), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! ':' symbol!", 16), ("regex -> '.'", 9), ("production -> symbol! ' '* '-' '>' ' '* regex!", 45), ("regex -> regex! '?'", 9), ("regex -> regex! '|' regex!", 16), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! ':' symbol!", 9), ('regex -> regex! regex!', 16)], {'!': ('s', 29), regex: ('g', 28), '(': ('s', 4), '+': ('s', 30), '*': ('s', 31), '.': ('s', 5), ANY(): ('s', 6), EOF: ('r', 16), '\\': ('s', 9), '[': ('s', 7), ':': ('s', 33), '{': ('s', 8), '?': ('s', 32), '|': ('s', 2)}, 47),
        #STATE 48
        State([('relem -> \\\\.!', 12)], {ANY(): ('r', 12), ']': ('r', 12), '-': ('r', 12), '\\': ('r', 12)}, 48),
        #STATE 49
        State([("regex -> regex! '!'", 16), ('regex -> \\\\.!', 9), ('START -> regex <EOF>', 15), ("regex -> regex! '|' regex!", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ('regex -> regex! regex!', 9), ("regex -> regex! '!'", 9), ("regex -> regex! '+'", 16), ("regex -> regex! '*'", 16), ("regex -> '(' regex! ')'", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ("regex -> regex! '+'", 9), ("regex -> regex! '*'", 9), ('regex -> [^()*+?!|{:[.\\\\]!', 9), ("regex -> regex! '?'", 16), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! ':' symbol!", 16), ("regex -> '.'", 9), ("regex -> regex! '?'", 9), ("regex -> regex! '|' regex!", 16), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! ':' symbol!", 9), ('regex -> regex! regex!', 16)], {'!': ('s', 29), regex: ('g', 28), EOF: ('a', None), '+': ('s', 30), '*': ('s', 31), '.': ('s', 5), ANY(): ('s', 6), '(': ('s', 4), '\\': ('s', 9), '[': ('s', 7), ':': ('s', 33), '{': ('s', 8), '?': ('s', 32), '|': ('s', 2)}, 49),
        #STATE 50
        State([('START -> regex <EOF>', 20)], {}, 50),
        #STATE 51
        State([("regex -> '(' regex! ')'", 23)], {'!': ('r', 15), ')': ('r', 15), EOF: ('r', 15), '+': ('r', 15), '*': ('r', 15), '.': ('r', 15), ANY(): ('r', 15), '(': ('r', 15), '\\': ('r', 15), '{': ('r', 15), ':': ('r', 15), '[': ('r', 15), '?': ('r', 15), '|': ('r', 15)}, 51),
        #STATE 52
        State([("production -> symbol! ' '* '-' '>' ' '* regex!", 31), ("production -> symbol! ' '* '-' '>' ' '* regex!", 31)], {'>': ('s', 53)}, 52),
        #STATE 53
        State([("regex -> regex! '+'", 9), ("production -> symbol! ' '* '-' '>' ' '* regex!", 40), ("regex -> '.'", 9), ("regex -> regex! '*'", 9), ("production -> symbol! ' '* '-' '>' ' '* regex!", 22), ("regex -> regex! '?'", 9), ("production -> symbol! ' '* '-' '>' ' '* regex!", 22), ('regex -> \\\\.!', 9), ("production -> symbol! ' '* '-' '>' ' '* regex!", 22), ("regex -> regex! '|' regex!", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ("production -> symbol! ' '* '-' '>' ' '* regex!", 22), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ("regex -> '(' regex! ')'", 9), ('regex -> [^()*+?!|{:[.\\\\]!', 9), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ('regex -> regex! regex!', 9), ("regex -> regex! ':' symbol!", 9), ("regex -> regex! '!'", 9)], {regex: ('g', 56), ' ': ('s', 40), '(': ('s', 4), '.': ('s', 5), ANY(): ('s', 6), _3: ('g', 42), '{': ('s', 8), '[': ('s', 7), '\\': ('s', 9), _2: ('g', 57)}, 53),
        #STATE 54
        State([('START -> production <EOF>', 20)], {EOF: ('a', None)}, 54),
        #STATE 55
        State([("production -> symbol! ' '* '-' '>' ' '* regex!", 27), ("production -> symbol! ' '* '-' '>' ' '* regex!", 22), ("production -> symbol! ' '* '-' '>' ' '* regex!", 22), ("production -> symbol! ' '* '-' '>' ' '* regex!", 22), ("production -> symbol! ' '* '-' '>' ' '* regex!", 22), ("production -> symbol! ' '* '-' '>' ' '* regex!", 22), ("production -> symbol! ' '* '-' '>' ' '* regex!", 27)], {_2: ('g', 43), '-': ('s', 52), _3: ('g', 42), ' ': ('s', 40)}, 55),
        #STATE 56
        State([("regex -> regex! '!'", 16), ('regex -> \\\\.!', 9), ("regex -> regex! '|' regex!", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ('regex -> regex! regex!', 9), ("regex -> regex! '!'", 9), ("regex -> regex! '+'", 16), ("regex -> regex! '*'", 16), ("production -> symbol! ' '* '-' '>' ' '* regex!", 45), ("regex -> '(' regex! ')'", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ("regex -> regex! '+'", 9), ("regex -> regex! '*'", 9), ('regex -> [^()*+?!|{:[.\\\\]!', 9), ("regex -> regex! '?'", 16), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! ':' symbol!", 16), ("regex -> '.'", 9), ("regex -> regex! '?'", 9), ("regex -> regex! '|' regex!", 16), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! ':' symbol!", 9), ('regex -> regex! regex!', 16)], {'!': ('s', 29), regex: ('g', 28), '(': ('s', 4), '+': ('s', 30), '*': ('s', 31), '.': ('s', 5), ANY(): ('s', 6), EOF: ('r', 23), '\\': ('s', 9), '[': ('s', 7), ':': ('s', 33), '{': ('s', 8), '?': ('s', 32), '|': ('s', 2)}, 56),
        #STATE 57
        State([("regex -> regex! '+'", 9), ("regex -> '.'", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ("regex -> regex! '*'", 9), ("production -> symbol! ' '* '-' '>' ' '* regex!", 22), ("regex -> regex! '?'", 9), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! '|' regex!", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ("regex -> '(' regex! ')'", 9), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("production -> symbol! ' '* '-' '>' ' '* regex!", 40), ('regex -> \\\\.!', 9), ("production -> symbol! ' '* '-' '>' ' '* regex!", 22), ('regex -> [^()*+?!|{:[.\\\\]!', 9), ('regex -> regex! regex!', 9), ("regex -> regex! ':' symbol!", 9), ("regex -> regex! '!'", 9)], {regex: ('g', 58), ' ': ('s', 40), '(': ('s', 4), '.': ('s', 5), ANY(): ('s', 6), _3: ('g', 44), '[': ('s', 7), '{': ('s', 8), '\\': ('s', 9)}, 57),
        #STATE 58
        State([("regex -> regex! '!'", 16), ('regex -> \\\\.!', 9), ("regex -> regex! '|' regex!", 9), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ('regex -> regex! regex!', 9), ("regex -> regex! '!'", 9), ("regex -> regex! '+'", 16), ("regex -> regex! '*'", 16), ("regex -> '(' regex! ')'", 9), ("production -> symbol! ' '* '-' '>' ' '* regex!", 45), ("regex -> '{' symbol! (':' symbol!)? '}'", 9), ("regex -> regex! '+'", 9), ("regex -> regex! '*'", 9), ('regex -> [^()*+?!|{:[.\\\\]!', 9), ("regex -> regex! '?'", 16), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! ':' symbol!", 16), ("regex -> '.'", 9), ("regex -> regex! '?'", 9), ("regex -> regex! '|' regex!", 16), ("regex -> '[' '^'?:inv srange!+! ']'", 9), ("regex -> regex! ':' symbol!", 9), ('regex -> regex! regex!', 16)], {'!': ('s', 29), regex: ('g', 28), '(': ('s', 4), '+': ('s', 30), '*': ('s', 31), '.': ('s', 5), ANY(): ('s', 6), EOF: ('r', 24), '\\': ('s', 9), '[': ('s', 7), ':': ('s', 33), '{': ('s', 8), '?': ('s', 32), '|': ('s', 2)}, 58),
        #STATE 59
        State([("regex -> '{' symbol! (':' symbol!)? '}'", 39)], {'!': ('r', 27), ')': ('r', 27), EOF: ('r', 27), '+': ('r', 27), '*': ('r', 27), '.': ('r', 27), ANY(): ('r', 27), '?': ('r', 27), '(': ('r', 27), '[': ('r', 27), ':': ('r', 27), '{': ('r', 27), '\\': ('r', 27), '|': ('r', 27)}, 59),
        ]

    TABLE.rules = [
        Rule(_6, 2, 'APPEND', ([Ref(0), Ref(1)], {})),
        Rule(regex, 2, 'match_escape', ([Ref(1)], {})),
        Rule(srange, 3, 'match_range', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(symbol, 1, 'match_name', ([Ref(0)], {})),
        Rule(regex, 3, 'match_symbol', ([Ref(1)], {})),
        Rule(regex, 2, 'match_cat', ([Ref(0), Ref(1)], {})),
        Rule(regex, 3, 'match_named', ([Ref(0), Ref(2)], {})),
        Rule(_5, 2, 'APPEND', ([Ref(0), Ref(1)], {})),
        Rule(regex, 4, 'match_set', ([Ref(2)], {'inv': True})),
        Rule(regex, 3, 'match_set', ([Ref(1)], {'inv': False})),
        Rule(regex, 2, 'match_arg', ([Ref(0)], {})),
        Rule(_2, 1, 'LIST', ([Ref(0)], {})),
        Rule(relem, 2, 'match_rescape', ([Ref(1)], {})),
        Rule(regex, 2, 'match_opt', ([Ref(0)], {})),
        Rule(regex, 1, 'match_any', ([], {})),
        Rule(regex, 3, 'COPY', ([Ref(1)], {})),
        Rule(production, 6, 'match_production', ([Ref(0), Ref(5)], {})),
        Rule(srange, 1, 'match_range', ([], {'a': Ref(0)})),
        Rule(relem, 1, 'COPY', ([Ref(0)], {})),
        Rule(production, 5, 'match_production', ([Ref(0), Ref(4)], {})),
        Rule(regex, 2, 'match_seq1', ([Ref(0)], {})),
        Rule(_3, 1, 'COPY', ([Ref(0)], {})),
        Rule(_2, 2, 'APPEND', ([Ref(0), Ref(1)], {})),
        Rule(production, 4, 'match_production', ([Ref(0), Ref(3)], {})),
        Rule(production, 5, 'match_production', ([Ref(0), Ref(4)], {})),
        Rule(regex, 3, 'match_alt', ([Ref(0), Ref(2)], {})),
        Rule(_5, 1, 'LIST', ([Ref(0)], {})),
        Rule(regex, 5, 'match_symbol', ([Ref(1), Ref(3)], {})),
        Rule(regex, 1, 'match_text', ([Ref(0)], {})),
        Rule(_6, 1, 'LIST', ([Ref(0)], {})),
        Rule(regex, 2, 'match_seq0', ([Ref(0)], {})),
        ]

class EBNFLexical (EBNFLexicalGrammar, grammar.engine.SourceTrace, grammar.eng_fsm.LexicalAnalyser, grammar.eng_fsm.FiniteStateMachine):
    from grammar.eng_fsm import FSMTable, State
    TABLE = FSMTable('EBNFLexicalGrammar', 1)
    TABLE.states = [
        State('', {'!': (2, 'LITERAL_TOKEN'), ' ': (3, 'SPACE'), "'": (4, None), ')': (1, 'LITERAL_TOKEN'), '(': (1, 'LITERAL_TOKEN'), '+': (1, 'LITERAL_TOKEN'), '*': (1, 'LITERAL_TOKEN'), '-': (5, None), ',': (1, 'LITERAL_TOKEN'), '.': (1, 'LITERAL_TOKEN'), '1': (6, 'SYMBOL'), '0': (6, 'SYMBOL'), '3': (6, 'SYMBOL'), '2': (6, 'SYMBOL'), '5': (6, 'SYMBOL'), '4': (6, 'SYMBOL'), '7': (6, 'SYMBOL'), '6': (6, 'SYMBOL'), '9': (6, 'SYMBOL'), '8': (6, 'SYMBOL'), ':': (1, 'LITERAL_TOKEN'), '?': (1, 'LITERAL_TOKEN'), 'A': (6, 'SYMBOL'), 'C': (6, 'SYMBOL'), 'B': (6, 'SYMBOL'), 'E': (6, 'SYMBOL'), 'D': (6, 'SYMBOL'), 'G': (6, 'SYMBOL'), 'F': (6, 'SYMBOL'), 'I': (6, 'SYMBOL'), 'H': (6, 'SYMBOL'), 'K': (6, 'SYMBOL'), 'J': (6, 'SYMBOL'), 'M': (6, 'SYMBOL'), 'L': (6, 'SYMBOL'), 'O': (6, 'SYMBOL'), 'N': (6, 'SYMBOL'), 'Q': (6, 'SYMBOL'), 'P': (6, 'SYMBOL'), 'S': (6, 'SYMBOL'), 'R': (6, 'SYMBOL'), 'U': (6, 'SYMBOL'), 'T': (6, 'SYMBOL'), 'W': (6, 'SYMBOL'), 'V': (6, 'SYMBOL'), 'Y': (6, 'SYMBOL'), 'X': (6, 'SYMBOL'), 'Z': (6, 'SYMBOL'), '_': (6, 'SYMBOL'), 'a': (6, 'SYMBOL'), 'c': (6, 'SYMBOL'), 'b': (6, 'SYMBOL'), 'e': (6, 'SYMBOL'), 'd': (6, 'SYMBOL'), 'g': (6, 'SYMBOL'), 'f': (6, 'SYMBOL'), 'i': (6, 'SYMBOL'), 'h': (6, 'SYMBOL'), 'k': (6, 'SYMBOL'), 'j': (6, 'SYMBOL'), 'm': (6, 'SYMBOL'), 'l': (6, 'SYMBOL'), 'o': (6, 'SYMBOL'), 'n': (6, 'SYMBOL'), 'q': (6, 'SYMBOL'), 'p': (6, 'SYMBOL'), 's': (6, 'SYMBOL'), 'r': (6, 'SYMBOL'), 'u': (6, 'SYMBOL'), 't': (6, 'SYMBOL'), 'w': (6, 'SYMBOL'), 'v': (6, 'SYMBOL'), 'y': (6, 'SYMBOL'), 'x': (6, 'SYMBOL'), 'z': (6, 'SYMBOL'), '|': (1, 'LITERAL_TOKEN')}, 0),
        State('', {}, 1),
        State('', {'!': (1, 'LITERAL_TOKEN')}, 2),
        State('', {' ': (3, 'SPACE')}, 3),
        State('', {ANY(): (7, 'literal_char'), '\\': (8, None), "'": ('e', None)}, 4),
        State('', {'>': (1, 'LITERAL_TOKEN')}, 5),
        State('', {'1': (6, 'SYMBOL'), '0': (6, 'SYMBOL'), '3': (6, 'SYMBOL'), '2': (6, 'SYMBOL'), '5': (6, 'SYMBOL'), '4': (6, 'SYMBOL'), '7': (6, 'SYMBOL'), '6': (6, 'SYMBOL'), '9': (6, 'SYMBOL'), '8': (6, 'SYMBOL'), 'A': (6, 'SYMBOL'), 'C': (6, 'SYMBOL'), 'B': (6, 'SYMBOL'), 'E': (6, 'SYMBOL'), 'D': (6, 'SYMBOL'), 'G': (6, 'SYMBOL'), 'F': (6, 'SYMBOL'), 'I': (6, 'SYMBOL'), 'H': (6, 'SYMBOL'), 'K': (6, 'SYMBOL'), 'J': (6, 'SYMBOL'), 'M': (6, 'SYMBOL'), 'L': (6, 'SYMBOL'), 'O': (6, 'SYMBOL'), 'N': (6, 'SYMBOL'), 'Q': (6, 'SYMBOL'), 'P': (6, 'SYMBOL'), 'S': (6, 'SYMBOL'), 'R': (6, 'SYMBOL'), 'U': (6, 'SYMBOL'), 'T': (6, 'SYMBOL'), 'W': (6, 'SYMBOL'), 'V': (6, 'SYMBOL'), 'Y': (6, 'SYMBOL'), 'X': (6, 'SYMBOL'), 'Z': (6, 'SYMBOL'), '_': (6, 'SYMBOL'), 'a': (6, 'SYMBOL'), 'c': (6, 'SYMBOL'), 'b': (6, 'SYMBOL'), 'e': (6, 'SYMBOL'), 'd': (6, 'SYMBOL'), 'g': (6, 'SYMBOL'), 'f': (6, 'SYMBOL'), 'i': (6, 'SYMBOL'), 'h': (6, 'SYMBOL'), 'k': (6, 'SYMBOL'), 'j': (6, 'SYMBOL'), 'm': (6, 'SYMBOL'), 'l': (6, 'SYMBOL'), 'o': (6, 'SYMBOL'), 'n': (6, 'SYMBOL'), 'q': (6, 'SYMBOL'), 'p': (6, 'SYMBOL'), 's': (6, 'SYMBOL'), 'r': (6, 'SYMBOL'), 'u': (6, 'SYMBOL'), 't': (6, 'SYMBOL'), 'w': (6, 'SYMBOL'), 'v': (6, 'SYMBOL'), 'y': (6, 'SYMBOL'), 'x': (6, 'SYMBOL'), 'z': (6, 'SYMBOL')}, 6),
        State('', {ANY(): (7, 'literal_char'), '\\': (8, None), "'": (1, 'match_literal')}, 7),
        State('', {ANY(): (7, 'literal_char')}, 8),
        ]

class EBNFParser (EBNFGrammar, grammar.engine.SourceTrace, grammar.eng_sr.ShiftReduceEngine):
    from grammar.eng_sr import ShiftReduceTable, State, Rule
    ebnf = EBNFGrammar.ebnf
    SYMBOL = EBNFGrammar.SYMBOL
    LITERAL = EBNFGrammar.LITERAL
    production = EBNFGrammar.production

    TABLE = ShiftReduceTable('EBNFGrammar')
    TABLE.states = [
        #STATE 0
        State([("production -> SYMBOL! '->' ebnf!", 14), ('START -> production <EOF>', 9)], {production: ('g', 1), SYMBOL: ('s', 2)}, 0),
        #STATE 1
        State([('START -> production <EOF>', 20)], {EOF: ('a', None)}, 1),
        #STATE 2
        State([("production -> SYMBOL! '->' ebnf!", 22)], {'->': ('s', 18)}, 2),
        #STATE 3
        State([("ebnf -> ebnf! '|' ebnf!", 18), ("ebnf -> ebnf! '?'", 8), ('ebnf -> SYMBOL!', 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! '!!'", 8), ("ebnf -> ebnf! '!'", 8), ('ebnf -> LITERAL!', 8), ("ebnf -> '(' ebnf! ')'", 8), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 8), ('ebnf -> ebnf! ebnf!', 8), ("ebnf -> ebnf! '|' ebnf!", 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! ':' SYMBOL!", 8)], {'(': ('s', 4), SYMBOL: ('s', 7), ebnf: ('g', 5), LITERAL: ('s', 6)}, 3),
        #STATE 4
        State([("ebnf -> '(' ebnf! ')'", 12), ("ebnf -> ebnf! '?'", 8), ('ebnf -> SYMBOL!', 8), ('ebnf -> ebnf! ebnf!', 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! '!!'", 8), ("ebnf -> ebnf! '!'", 8), ('ebnf -> LITERAL!', 8), ("ebnf -> '(' ebnf! ')'", 8), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! '|' ebnf!", 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! ':' SYMBOL!", 8)], {'(': ('s', 4), SYMBOL: ('s', 7), ebnf: ('g', 8), LITERAL: ('s', 6)}, 4),
        #STATE 5
        State([("ebnf -> ebnf! ':' SYMBOL!", 8), ('ebnf -> LITERAL!', 8), ("ebnf -> ebnf! '!'", 8), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 14), ("ebnf -> ebnf! '|' ebnf!", 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 14), ("ebnf -> '(' ebnf! ')'", 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 14), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! '!!'", 8), ("ebnf -> ebnf! '|' ebnf!", 22), ("ebnf -> ebnf! '?'", 14), ('ebnf -> ebnf! ebnf!', 8), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 14), ('ebnf -> SYMBOL!', 8), ("ebnf -> ebnf! '!!'", 14), ("ebnf -> ebnf! '?'", 8), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! ':' SYMBOL!", 14), ('ebnf -> ebnf! ebnf!', 14), ("ebnf -> ebnf! '!'", 14), ("ebnf -> ebnf! '|' ebnf!", 14)], {'!!': ('s', 9), '!': ('s', 10), ')': ('r', 2), '(': ('s', 4), '+': ('s', 12), '*': ('s', 13), '|': ('r', 2), ebnf: ('g', 14), EOF: ('r', 2), ':': ('s', 15), SYMBOL: ('s', 7), '?': ('s', 16), LITERAL: ('s', 6)}, 5),
        #STATE 6
        State([('ebnf -> LITERAL!', 15)], {'!!': ('r', 4), '!': ('r', 4), ')': ('r', 4), EOF: ('r', 4), '+': ('r', 4), '*': ('r', 4), SYMBOL: ('r', 4), LITERAL: ('r', 4), '(': ('r', 4), ':': ('r', 4), '|': ('r', 4), '?': ('r', 4)}, 6),
        #STATE 7
        State([('ebnf -> SYMBOL!', 14)], {'!!': ('r', 9), '!': ('r', 9), ')': ('r', 9), EOF: ('r', 9), '+': ('r', 9), '*': ('r', 9), '|': ('r', 9), LITERAL: ('r', 9), '(': ('r', 9), ':': ('r', 9), SYMBOL: ('r', 9), '?': ('r', 9)}, 7),
        #STATE 8
        State([("ebnf -> ebnf! ':' SYMBOL!", 8), ('ebnf -> LITERAL!', 8), ("ebnf -> ebnf! '!'", 8), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 14), ("ebnf -> ebnf! '|' ebnf!", 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 14), ("ebnf -> '(' ebnf! ')'", 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 8), ('ebnf -> ebnf! ebnf!', 14), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! '!!'", 8), ("ebnf -> ebnf! '?'", 14), ('ebnf -> ebnf! ebnf!', 8), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 14), ('ebnf -> SYMBOL!', 8), ("ebnf -> ebnf! '!!'", 14), ("ebnf -> ebnf! '?'", 8), ("ebnf -> '(' ebnf! ')'", 18), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! ':' SYMBOL!", 14), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 14), ("ebnf -> ebnf! '!'", 14), ("ebnf -> ebnf! '|' ebnf!", 14)], {'!!': ('s', 9), '!': ('s', 10), ')': ('s', 11), '(': ('s', 4), '+': ('s', 12), '*': ('s', 13), '|': ('s', 3), ebnf: ('g', 14), ':': ('s', 15), SYMBOL: ('s', 7), '?': ('s', 16), LITERAL: ('s', 6)}, 8),
        #STATE 9
        State([("ebnf -> ebnf! '!!'", 18)], {'!!': ('r', 6), '!': ('r', 6), ')': ('r', 6), EOF: ('r', 6), '+': ('r', 6), '*': ('r', 6), '|': ('r', 6), LITERAL: ('r', 6), '(': ('r', 6), ':': ('r', 6), SYMBOL: ('r', 6), '?': ('r', 6)}, 9),
        #STATE 10
        State([("ebnf -> ebnf! '!'", 17)], {'!!': ('r', 11), '!': ('r', 11), ')': ('r', 11), EOF: ('r', 11), '+': ('r', 11), '*': ('r', 11), '|': ('r', 11), LITERAL: ('r', 11), '(': ('r', 11), ':': ('r', 11), SYMBOL: ('r', 11), '?': ('r', 11)}, 10),
        #STATE 11
        State([("ebnf -> '(' ebnf! ')'", 21)], {'!!': ('r', 8), '!': ('r', 8), ')': ('r', 8), EOF: ('r', 8), '+': ('r', 8), '*': ('r', 8), SYMBOL: ('r', 8), LITERAL: ('r', 8), '(': ('r', 8), ':': ('r', 8), '|': ('r', 8), '?': ('r', 8)}, 11),
        #STATE 12
        State([("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 20), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 17)], {'!!': ('r', 0), '!': ('r', 0), ')': ('r', 0), EOF: ('r', 0), '+': ('r', 0), '*': ('r', 0), ',': ('s', 17), '|': ('r', 0), LITERAL: ('r', 0), '(': ('r', 0), ':': ('r', 0), SYMBOL: ('r', 0), '?': ('r', 0)}, 12),
        #STATE 13
        State([("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 17), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 20)], {'!!': ('r', 3), '!': ('r', 3), ')': ('r', 3), EOF: ('r', 3), '+': ('r', 3), '*': ('r', 3), ',': ('s', 19), SYMBOL: ('r', 3), LITERAL: ('r', 3), '(': ('r', 3), ':': ('r', 3), '|': ('r', 3), '?': ('r', 3)}, 13),
        #STATE 14
        State([("ebnf -> ebnf! ':' SYMBOL!", 8), ('ebnf -> ebnf! ebnf!', 18), ('ebnf -> LITERAL!', 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! '!'", 8), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 14), ("ebnf -> ebnf! '|' ebnf!", 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 14), ("ebnf -> '(' ebnf! ')'", 8), ("ebnf -> ebnf! '!!'", 14), ('ebnf -> ebnf! ebnf!', 14), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! '!!'", 8), ("ebnf -> ebnf! '?'", 14), ('ebnf -> ebnf! ebnf!', 8), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 14), ('ebnf -> SYMBOL!', 8), ("ebnf -> ebnf! '?'", 8), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! ':' SYMBOL!", 14), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 14), ("ebnf -> ebnf! '!'", 14), ("ebnf -> ebnf! '|' ebnf!", 14)], {'!!': ('s', 9), '!': ('s', 10), ')': ('r', 7), '(': ('s', 4), '+': ('s', 12), '*': ('s', 13), '|': ('r', 7), ebnf: ('g', 14), EOF: ('r', 7), ':': ('s', 15), SYMBOL: ('s', 7), '?': ('s', 16), LITERAL: ('s', 6)}, 14),
        #STATE 15
        State([("ebnf -> ebnf! ':' SYMBOL!", 18)], {SYMBOL: ('s', 22)}, 15),
        #STATE 16
        State([("ebnf -> ebnf! '?'", 17)], {'!!': ('r', 12), '!': ('r', 12), ')': ('r', 12), EOF: ('r', 12), '+': ('r', 12), '*': ('r', 12), '|': ('r', 12), LITERAL: ('r', 12), '(': ('r', 12), ':': ('r', 12), SYMBOL: ('r', 12), '?': ('r', 12)}, 16),
        #STATE 17
        State([("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 24)], {LITERAL: ('s', 23)}, 17),
        #STATE 18
        State([("ebnf -> ebnf! '?'", 8), ('ebnf -> SYMBOL!', 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 8), ("production -> SYMBOL! '->' ebnf!", 27), ("ebnf -> ebnf! '!!'", 8), ("ebnf -> ebnf! '!'", 8), ('ebnf -> LITERAL!', 8), ("ebnf -> '(' ebnf! ')'", 8), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 8), ('ebnf -> ebnf! ebnf!', 8), ("ebnf -> ebnf! '|' ebnf!", 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! ':' SYMBOL!", 8)], {'(': ('s', 4), SYMBOL: ('s', 7), ebnf: ('g', 24), LITERAL: ('s', 6)}, 18),
        #STATE 19
        State([("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 24)], {LITERAL: ('s', 20)}, 19),
        #STATE 20
        State([("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 31)], {'!!': ('r', 1), '!': ('r', 1), ')': ('r', 1), EOF: ('r', 1), '+': ('r', 1), '*': ('r', 1), SYMBOL: ('r', 1), LITERAL: ('r', 1), '(': ('r', 1), ':': ('r', 1), '|': ('r', 1), '?': ('r', 1)}, 20),
        #STATE 21
        State([('START -> production <EOF>', 25)], {}, 21),
        #STATE 22
        State([("ebnf -> ebnf! ':' SYMBOL!", 24)], {'!!': ('r', 10), '!': ('r', 10), ')': ('r', 10), EOF: ('r', 10), '+': ('r', 10), '*': ('r', 10), SYMBOL: ('r', 10), LITERAL: ('r', 10), '(': ('r', 10), ':': ('r', 10), '|': ('r', 10), '?': ('r', 10)}, 22),
        #STATE 23
        State([("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 31)], {'!!': ('r', 5), '!': ('r', 5), ')': ('r', 5), EOF: ('r', 5), '+': ('r', 5), '*': ('r', 5), '|': ('r', 5), LITERAL: ('r', 5), '(': ('r', 5), ':': ('r', 5), SYMBOL: ('r', 5), '?': ('r', 5)}, 23),
        #STATE 24
        State([("ebnf -> ebnf! ':' SYMBOL!", 8), ('ebnf -> LITERAL!', 8), ("ebnf -> ebnf! '!'", 8), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 14), ("ebnf -> ebnf! '|' ebnf!", 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 14), ("ebnf -> '(' ebnf! ')'", 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 14), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! '*' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! '!!'", 8), ("ebnf -> ebnf! '?'", 14), ('ebnf -> ebnf! ebnf!', 8), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 14), ('ebnf -> SYMBOL!', 8), ("production -> SYMBOL! '->' ebnf!", 31), ("ebnf -> ebnf! '!!'", 14), ("ebnf -> ebnf! '?'", 8), ("ebnf -> ebnf! '+' ( ',' LITERAL! )?", 8), ("ebnf -> ebnf! ':' SYMBOL!", 14), ('ebnf -> ebnf! ebnf!', 14), ("ebnf -> ebnf! '!'", 14), ("ebnf -> ebnf! '|' ebnf!", 14)], {'!!': ('s', 9), '!': ('s', 10), '(': ('s', 4), '+': ('s', 12), '*': ('s', 13), '|': ('s', 3), ebnf: ('g', 14), EOF: ('r', 13), ':': ('s', 15), SYMBOL: ('s', 7), '?': ('s', 16), LITERAL: ('s', 6)}, 24),
        ]

    TABLE.rules = [
        Rule(ebnf, 2, 'match_seq1', ([Ref(0)], {})),
        Rule(ebnf, 4, 'match_seq0', ([Ref(0), Ref(3)], {})),
        Rule(ebnf, 3, 'match_alt', ([Ref(0), Ref(2)], {})),
        Rule(ebnf, 2, 'match_seq0', ([Ref(0)], {})),
        Rule(ebnf, 1, 'match_text', ([Ref(0)], {})),
        Rule(ebnf, 4, 'match_seq1', ([Ref(0), Ref(3)], {})),
        Rule(ebnf, 2, 'match_dictarg', ([Ref(0)], {})),
        Rule(ebnf, 2, 'match_cat', ([Ref(0), Ref(1)], {})),
        Rule(ebnf, 3, 'COPY', ([Ref(1)], {})),
        Rule(ebnf, 1, 'match_symbol', ([Ref(0)], {})),
        Rule(ebnf, 3, 'match_named', ([Ref(0), Ref(2)], {})),
        Rule(ebnf, 2, 'match_arg', ([Ref(0)], {})),
        Rule(ebnf, 2, 'match_opt', ([Ref(0)], {})),
        Rule(production, 3, 'match_production', ([Ref(0), Ref(2)], {})),
        ]


PATTERN_PARSE[:] = [RegexParser, EBNFLexical, EBNFParser]
