
class PythonWriter:
    def __init__(self, f, src=None):
        if isinstance(f, str):
            self.name = True
            self.fn = f
        else:
            self.name = False
            self.fn = None
            try:
                self.fn = f.filename
            except:
                pass
            self.f = f
        self.src = src
        self.parsers = []

    def add(self, p):
        self.parsers.append(p)

    def write(self, head='', tail=''):
        if self.name:
            self.f = open(self.fn, 'w')
        self.f.write(head)
        self.includes()
        for p in self.parsers:
            self.wp(p)
        self.f.write(tail)
        if self.name:
            self.f.close()

    def wp(self, p):
        self.f.write('class {} ({}{}):\n'
                     .format(p.__name__, p.__bases__[0].__name__,
                             ''.join(', '+x.__module__+'.'+x.__name__
                                       for x in p.__bases__[1:])))
        p.TABLE.write_py(self.f, '    ')

    def includes(self):
        self.f.write('from grammar.grammar import ANY, TYP, EOF, Ref,'
                     ' NonTerminal\n')
        mset = set()
        for p in self.parsers:
            for b in p.__bases__[1:]:
                mset.add(b.__module__.split('.')[0])
            b = p.__bases__[0]
            if self.src is None:
                mod = b.__module__
            else:
                mod = self.src
            self.f.write("from {} import {}\n".format(mod, b.__name__))
        self.f.write("import {}\n\n".format(', '.join(mset)))
